;redcode
;name Vlad v3.3
;author B. Cook <bpc25@cam.ac.uk>
;strategy B-scan drops fangs to suicidal 2-pass clear
;assert 1==1

org	loop

cnst	equ	3315			;mod 5 scanning
gate	equ	15

beg	dat	#cnst,	#-cnst		;used to update fang

fang	jmp	trap,	0		;fang used, hits here

loop	add.f	beg,	fang		;moves fang loc and sets jmp to trap
	jmz.f	loop,	@fang		;renew pointer if no target
bite	mov.i	fang,	@fang		;drops fang if target not 0,0
	jmp	loop,	<beg-gate	;scan again

bmb2	dat	0,	0		;2nd pass, scan here

trap	mov.i	*clr1,	<clr1		;split-dat suicidal...
bmb1	spl	#(bmb2-clr1),	<beg-gate	;1st pass & ptr for 2nd
	jmp	trap,	<beg-gate	;...coreclear
clr1	dat	bmb1,	beg-1		;pointer for clear