;redcode
;name Vlad v3
;author B. Cook <bpc25@cam.ac.uk>
;strategy B-scan drops fangs to suicidal 2-pass clear
;assert 1==1

org	loop

cnst	equ	3364			;mod 4 scanning
gate	equ	14

beg	dat	$0,	$0		;impgate gate above here

fang	jmp	trap,	0		;fang used, hits here

loop	add.f	ptr,	fang		;moves fang loc and sets jmp to trap
	jmz.f	loop,	@fang		;dosen't bite if instr is 0,0
	jmp	bite,	<beg-gate	;jmps to bite

	dat	0,	0		;scans here

bite	mov.i	fang,	@fang		;drops fang if instr not 0,0
	jmp	loop,	<beg-gate	;goes back to scanning
ptr	dat	#cnst,	#-cnst		;added to fang

	dat	0,	0		;scans here

trap	spl	1,	<beg-gate	;trap is a 2-pass
	mov.i	*clr1,	<clr1		;split-dat suicidal
	jmp	trap,	<beg-gate	;coreclear

	dat	0,	0		;scans here

clr3	dat	0,	-1		;second pass clear-suicidal
clr2	spl	#(clr3-clr1),	beg-8	;first pass clear
clr1	dat	clr2,	beg-8		;pointer for trap clear

	end